

bool rgb2hsv(int * rgb, double * hsv)
{
    double min, max, delta;

    min = rgb[0] < rgb[1] ? rgb[0] : rgb[1];
    min = min  < rgb[2] ? min  :rgb[2];

    max = rgb[0] > rgb[1] ? rgb[0] : rgb[1];
    max = max  > rgb[2] ? max  : rgb[2];

    hsv[2] = max;                                // v
    delta = max - min;
    if (delta < 0.00001)
    {
        hsv[1] = 0;
        hsv[0] = 0; // undefined, maybe nan?
        return false;
    }
    if( max > 0.0 ) { // NOTE: if Max is == 0, this divide would cause a crash
        hsv[1] = (delta / max);                  // s
    } else {
        // if max is 0, then r = g = b = 0              
            // s = 0, v is undefined
        hsv[1] = 0.0;
        hsv[0] = NAN;                            // its now undefined
        return false;
    }
    if( rgb[0] >= max )                           // > is bogus, just keeps compilor happy
        hsv[0] = ( rgb[1] - rgb[2] ) / delta;        // between yellow & magenta
    else
    if( rgb[1] >= max )
        hsv[0] = 2.0 + ( rgb[2] - rgb[0] ) / delta;  // between cyan & yellow
    else
        hsv[0] = 4.0 + ( rgb[0] - rgb[1] ) / delta;  // between magenta & cyan

    hsv[0] *= 60.0;                              // degrees

    if( hsv[0] < 0.0 )
        hsv[0] += 360.0;

    //removing black and white
    if (hsv[1] < 0.35 || hsv[2] < 70) return false;    
    return true;
}

